//This file was generated from UPPAAL 3.3.35, Mar 2003

/*
===== Validation Properties:
*/
//NO_QUERY

/*
Gate can receive (and store in queue) msg's from approaching trains.
*/
E<> Gate.Occ

/*
Train 1 can reach crossing.
*/
E<> Train1.Cross

/*
Train 2 can reach crossing.
*/
E<> Train2.Cross

/*
Train 1 can be crossing bridge while Train 2 is waiting to cross.
*/
E<> Train1.Cross and Train2.Stop

/*
Train 1 can cross bridge while Train 2, 3 & 4 are waiting to cross.
*/
E<> Train1.Cross and Train2.Stop and Train3.Stop and Train4.Stop

/*
===== Safety Properties:
*/
//NO_QUERY

/*
There is never more than one train crossing the bridge (at
any time instance).
*/
A[] Train1.Cross + Train2.Cross + Train3.Cross + Train4.Cross <= 1

/*
There can never be N elements in the queue (thus the array will not overflow).
*/
A[] Queue.list[N-1] == 0

/*
===== Liveness Properties:
*/
//NO_QUERY

/*
Whenever a train approaches the bridge, it will eventually cross.
*/
Train1.Appr --> Train1.Cross\
\


/*

*/
Train2.Appr --> Train2.Cross

/*

*/
Train3.Appr --> Train3.Cross

/*

*/
Train4.Appr --> Train4.Cross

/*
===== Deadlock checking:
*/
//NO_QUERY

/*
The system is deadlock-free.
*/
A[] not deadlock
